
#include <AccelStepper.h>

///////////Hardware Pin's
//Circular Motor
int CircularStepper_dir = 5;
int CircularStepper_step = 4;

//Vertical Motor
int Verticalstepper_dir = 7;
int Verticalstepper_step = 6;

//Switch control_Left of Vertical Motor
int LeftSwitch_PIN = 12;
int LeftSwitch_state  =0;

//Switch control_right of Vertical Motor
//int button_1_PIN = XXXXXX;
//int button_1_PIN_state =0;

//Driver Configuration - MicroSteps
int microstep =16;
float full_rev = 200 * microstep;

//Entry Values coming from Raspberry
int CircularDegrees = 360*2;
int VerticalDegrees = 360*2;

float Circular_steps = (CircularDegrees * full_rev)/360;

float Vertical_steps = (VerticalDegrees * full_rev)/360;


//Motor's initiation...

AccelStepper CircularStepper(AccelStepper::DRIVER, CircularStepper_dir, CircularStepper_step);
AccelStepper Verticalstepper(AccelStepper::DRIVER, Verticalstepper_dir, Verticalstepper_step);

void setup()
{
  pinMode(LeftSwitch_PIN, INPUT_PULLUP);
  
  CircularStepper.setMaxSpeed(700000);
  CircularStepper.setAcceleration(2000.0);
  CircularStepper.moveTo(Circular_steps);

  Verticalstepper.setMaxSpeed(700000);
  Verticalstepper.setAcceleration(2000.0);
  Verticalstepper.moveTo(Vertical_steps);
}

void loop()
{
   LeftSwitch_state = digitalRead(LeftSwitch_PIN);
   if (LeftSwitch_state == 1){
      RunMotors();
     LeftSwitch_state = 0 ;
   }else{
      StopMotors();
    }
    LeftSwitch_state = digitalRead(LeftSwitch_PIN);
}

void RunMotors(){
   CircularStepper.run();
   Verticalstepper.run();
  }

 void StopMotors(){
    Circular_steps = 0;
    Vertical_steps = 0;
    CircularStepper.setMaxSpeed(0);
    CircularStepper.setAcceleration(0.0);
    CircularStepper.moveTo(Circular_steps);
    
    Verticalstepper.setMaxSpeed(0);
    Verticalstepper.setAcceleration(0.0);
    Verticalstepper.moveTo(Vertical_steps);
  }
